## fzifdso 0.4.1

=== Makefile ===
# SPDX-License-Identifier: MIT


-include Makefile.local


FZIFDSO_VERSION ?= "$(patsubst v%,%,$(shell git describe || echo 0))"
SOURCE_DATE_EPOCH ?=
FZIFDSO_DATE ?=


AWK ?= awk
SED ?= sed
MANDOC ?= mandoc
PKG_CONFIG ?= pkgconf
SHELLCHECK ?= shellcheck

NOLOCREGEN ?=
OUTDIR := out/
BLDDIR := out/build/

ifneq "$(FZIFDSO_DATE)" ""
MANUAL_DATE := $(FZIFDSO_DATE)
else ifneq "$(SOURCE_DATE_EPOCH)" ""
MANUAL_DATE := $(shell LC_ALL=C date -d@$(SOURCE_DATE_EPOCH) '+%B %e, %Y')
else
MANUAL_DATE  = $(shell LC_ALL=C date -d@$(shell git log -1 --no-show-signature --format=%at $(1)) '+%B %e, %Y')
endif


PKGS := libzfs libzfs_core libfido2
PKG_CONFIG_LIBS   := $(shell $(PKG_CONFIG) --libs   $(PKGS))
PKG_CONFIG_CFLAGS := $(shell $(PKG_CONFIG) --cflags $(PKGS))

LDFLAGS  += -Wl,--as-needed
LDLIBS   += $(PKG_CONFIG_LIBS)
CXXFLAGS += -g -O3 -std=c++17 -fno-exceptions -fno-rtti -Wall -Wextra -pipe -fPIC $(PKG_CONFIG_CFLAGS)
CPPFLAGS += -MD -DFZIFDSO_VERSION='$(FZIFDSO_VERSION)'
BINARY_SOURCES := $(sort $(wildcard src/bin/*.cpp src/bin/**/*.cpp))
COMMON_SOURCES := $(filter-out $(BINARY_SOURCES),$(sort $(wildcard src/*.cpp src/**/*.cpp src/**/**/*.cpp src/**/**/**/*.cpp)))
MANPAGE_HEADERS := $(sort $(wildcard man/*.h))
MANPAGE_SOURCES := $(sort $(wildcard man/*.[0-8].pp))
INITRD_HEADERS := $(sort $(wildcard initrd/*.h))
ifneq (,$(shell command -v msgfmt))
	LOCALES := $(wildcard po/*.po)
endif


ifdef TZPFMS_PASSPHRASE_HELPER
CPPFLAGS += -DTZPFMS_PASSPHRASE_HELPER='$(TZPFMS_PASSPHRASE_HELPER)'
endif
ifdef TZPFMS_PASSPHRASE_HELPER_MAN
DEF_TPH_MAN := .Pp\nDefault:\n.No '\'' Ns $(TZPFMS_PASSPHRASE_HELPER_MAN) Ns '\'' .
else
DEF_TPH_MAN ?= .
endif


ifneq "$(findstring clang,$(shell $(CXX) --version))" ""
	# GCC doesn't have this granularity
	CXXFLAGS += -flto=full -pedantic -Wno-gnu-statement-expression -Wno-gnu-include-next -Wno-gnu-conditional-omitted-operand -Wno-variadic-macros -Wno-c99-extensions
	ifeq "$(AR)" "ar"
		# Need this because -flto=full produces objects FSF ranlib (ar s) can't index
		override AR := llvm-ar
	endif
else
	CXXFLAGS += -flto
endif



.PHONY : all locales clean build shellcheck i-t dracut init.d-systemd manpages htmlpages
.SECONDARY :


all : build locales manpages htmlpages shellcheck i-t dracut init.d-systemd

shellcheck : i-t dracut
	$(SHELLCHECK) --exclude SC1091,SC2093 $(foreach l,$(OUTDIR)initramfs-tools/ $(OUTDIR)dracut/ init.d/,$(wildcard $(l)*.sh $(l)**/*.sh $(l)**/**/*.sh $(l)**/**/**/*.sh $(l)**/**/**/**/*.sh $(l)**/**/**/**/**/*.sh $(l)**/**/**/**/**/**/*.sh $(l)**/**/**/**/**/**/**/*.sh $(l)**/**/**/**/**/**/**/**/*.sh))

clean :
	rm -rf $(OUTDIR)

build : $(subst src/bin/,$(OUTDIR),$(subst .cpp,,$(BINARY_SOURCES)))
manpages : $(patsubst man/%.pp,$(OUTDIR)man/%,$(MANPAGE_SOURCES))
htmlpages : $(patsubst man/%.pp,$(OUTDIR)man/%.html,$(MANPAGE_SOURCES)) $(OUTDIR)man/style.css
locales : $(patsubst po/%.po,$(OUTDIR)locale/%/LC_MESSAGES/fzifdso.mo,$(LOCALES))
i-t : $(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/fzifdso $(OUTDIR)initramfs-tools/usr/share/fzifdso/initramfs-tools-zfs-patch.sh
dracut : $(patsubst initrd/dracut/%,$(OUTDIR)dracut/usr/lib/dracut/modules.d/91fzifdso/%,$(sort $(wildcard initrd/dracut/*.sh)))
init.d-systemd : $(foreach l,$(subst init.d/systemd/usr-share-tzpfms/,,$(wildcard init.d/systemd/usr-share-tzpfms/*)),$(OUTDIR)systemd/usr/share/tzpfms/$(l))



$(BLDDIR)fzifdso.pot: src/*.[ch]pp src/bin/*.[ch]pp
	@mkdir -p $(@D)
	$(NOLOCREGEN)xgettext --check=ellipsis-unicode --from-code=UTF-8 -c -io- $^ | sed -n '/^#[:.]/,$$p' > $@
	$(NOLOCREGEN)$(foreach l,$(LOCALES),msgmerge --backup=off --no-wrap -Uiq $(l) $@ &&) :
	@>> $@

$(OUTDIR)locale/%/LC_MESSAGES/fzifdso.mo : po/%.po $(BLDDIR)fzifdso.pot
	@mkdir -p $(@D)
	msgfmt --statistics --check-format --check-domain -o $@ $<


$(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/fzifdso: initrd/initramfs-tools/hook $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@

$(OUTDIR)initramfs-tools/usr/share/fzifdso/initramfs-tools-zfs-patch.sh: initrd/initramfs-tools/zfs-patch.sh $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@

$(OUTDIR)systemd/usr/share/tzpfms/% : init.d/systemd/usr-share-tzpfms/%
	@mkdir -p $(dir $@)
	ln -f $< $@ || cp $< $@

# The d-v-o-s string starts at "BSD" (hence the "BSD General Commands Manual" default); we're not BSD, so hide it
# Can't put it at the very top, since man(1) only loads mdoc *after* the first mdoc macro (.Dd in our case)
$(OUTDIR)man/% : man/%.pp $(MANPAGE_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< TZPFMS_PASSPHRASE_HELPER_MAN='$(DEF_TPH_MAN)' | $(AWK) '/^$$/ {prev_empty=1; next} $$1 == "#" && $$2 ~ /^[0-9]*$$/ {prev_empty=0; next}  {if(prev_empty) print ""; prev_empty=0; print}' | $(AWK) '$$0 == ".Dd" {$$2 = "$(call MANUAL_DATE,$<)"}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  $$0 == ".Os" {$$2 = "fzifdso"; $$3 = $(FZIFDSO_VERSION)}  {print}' > $@
	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'STYLE: operating system explicitly specified: Os fzifdso' -e 'WARNING: cross reference to self: Xr zfs-fido.*-change-key 8' -e 'STYLE: input text line longer than 80 bytes'
# The "WARNING: unknown font, skipping request: TS.+fC[RBI]" one: see https://bugs.debian.org/992002

$(OUTDIR)man/%.html : $(OUTDIR)man/%
	@mkdir -p $(dir $@)
	( cd $(OUTDIR)man/ && $(MANDOC) -Thtml -Ostyle="style.css",man="%N.%S.html;https://manpages.debian.org/bookworm/%N.%S" ) < $< | \
		$(AWK) '/^<h1/ {in_syn = $$0 ~ /id="SYNOPSIS"/}  /^<br/ {if(in_syn) next}  {print}' | \
		$(SED) -Ee 's/ title=".."//g' -e 's/<a class="permalink" href="#([^"]*)"><span class="No" id="([^"]*)">/<a><span class="No">/g' > $@

$(OUTDIR)man/style.css : man/style.css
	@mkdir -p $(dir $@)
	cp $^ $@

$(BLDDIR)libfzifdso.a : $(subst src/,$(BLDDIR)obj/,$(subst .cpp,.o,$(COMMON_SOURCES)))
	$(AR) --thin crs $@ $^


$(OUTDIR)% : $(BLDDIR)obj/bin/%.o $(BLDDIR)libfzifdso.a
	@mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

$(BLDDIR)obj/%.o : src/%.cpp
	@mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c -o $@ $<

$(OUTDIR)dracut/usr/lib/dracut/modules.d/91fzifdso/% : initrd/dracut/% $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@


include $(wildcard $(BLDDIR)*/*.d $(BLDDIR)*/*/*.d)

## fzifdso 0.4.0

=== debian/changelog ===
fzifdso (0.4.0-1+bpo12~1) bookworm; urgency=medium

  * Rebuild for bookworm.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 29 Mar 2024 20:40:38 +0100

fzifdso (0.4.0-1) unstable; urgency=medium

  * Initial packaging, version 0.4.0 (+ changelog & NEWS)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 29 Mar 2024 13:51:23 +0100

=== debian/control ===
Source: fzifdso
Section: admin
Priority: optional
Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://git.sr.ht/~nabijaczleweli/fzifdso.deb
Vcs-Browser: https://git.sr.ht/~nabijaczleweli/fzifdso.deb
Homepage: https://sr.ht/~nabijaczleweli/fzifdso
Build-Depends: debhelper,
               debhelper-compat (= 13),
               mandoc <!nodoc>,
               pkg-config,
               libzfslinux-dev,
               libfido2-dev,
               libssl-dev,
               systemd-dev | systemd,
               gettext <!pkg.fzifdso.noloc>,

Package: fzifdso
Recommends: tzpfms-common (>= 0.4.0-1)
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
#Tag: admin::filesystem, implemented-in::c++, interface::commandline, role::program, scope::utility, use::configuring
Description: FIDO2 encryption keys for ZFS datasets – binaries
 fzifdso provides tooling to manage keys for encrypted ZFS datasets
 by binding them to FIDO2/WebAuthn devices (like the YubiKey, Somu, &c.),
 thus requiring the right device and a presence check to unlock.
 .
 This package contains zfs-fido2-{{change,list,clear}-key,add-backup}
 for managing keys backed by FIDO2 devices.

Package: fzifdso-dracut
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         tzpfms-common (>= 0.4.0-1),
         fzifdso,
         zfs-dracut,
#Tag: admin::filesystem, admin::boot, implemented-in::shell, role::plugin
Description: FIDO2 encryption keys for ZFS datasets – Dracut hooks
 fzifdso provides tooling to manage keys for encrypted ZFS datasets
 by binding them to FIDO2/WebAuthn devices (like the YubiKey, Somu, &c.),
 thus requiring the right device and a presence check to unlock.
 .
 This package contains Dracut hooks for booting with an encrypted ZFS rootfs
 backed by fzifdso.

Package: fzifdso-initramfs
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         tzpfms-common (>= 0.4.0-1),
         fzifdso,
         zfs-initramfs,
#Tag: admin::filesystem, admin::boot, implemented-in::shell, role::plugin
Description: FIDO2 encryption keys for ZFS datasets – initramfs-tools hooks
 fzifdso provides tooling to manage keys for encrypted ZFS datasets
 by binding them to FIDO2/WebAuthn devices (like the YubiKey, Somu, &c.),
 thus requiring the right device and a presence check to unlock.
 .
 This package contains initramfs-tools hooks for booting
 with an encrypted ZFS rootfs backed by fzifdso.

=== debian/watch ===
version=4
opts="filenamemangle=s/.*\/v?(\d\S+)\.tar\.gz/fzifdso-$1\.tar\.gz/, pgpsigurlmangle=s/$/.asc/" \
  https://git.sr.ht/~nabijaczleweli/fzifdso/refs .*/v?(\d\S+)\.tar\.gz

## fzifdso 0.4.1

=== debian/changelog ===
fzifdso (0.4.1-1) unstable; urgency=medium

  * New upstream version 0.4.1 (+ changelog & NEWS)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 09 Mar 2025 17:17:04 +0100

=== debian/rules ===
#!/usr/bin/make -f


export DEB_BUILD_MAINT_OPTIONS := hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export FZIFDSO_VERSION := "$(shell IFS="$$IFS()" read -r _ v _ < debian/changelog && echo "$$v")"
export TZ := UTC0
export NOLOCREGEN := @\#

targets := $(filter-out htmlpages shellcheck,$(shell sed -n '/^all :/s///p' Makefile))
ifneq "$(filter nodoc,$(DEB_BUILD_PROFILES))" ""
targets := $(filter-out %pages,$(targets))
endif


override_dh_auto_build:
	dh_auto_build -- $(targets) TZPFMS_PASSPHRASE_HELPER='exec systemd-ask-password --id="tzpfms:$$$$2" "$$$$1:"' TZPFMS_PASSPHRASE_HELPER_MAN='Ic exec Nm systemd-ask-password Fl -id Ns Li = Ns Qo Li tzpfms:\& Ns Ar $$$$2 Qc Qo Ar $$$$1 Ns Li ":\&" Qc'

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs -A README.md
	cp debian/NEWS.upstream debian/fzifdso/usr/share/doc/fzifdso/NEWS

%:
	dh $@
